/*
    yaokongqi Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "device/dr16.h"
#include "module/chassis.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
DR16_t dr16;
Chassis_CMD_t cmd_to_chassis;         // 控制命令
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_yaokongqi(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / YAOKONGQI_FREQ;

  osDelay(YAOKONGQI_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */

  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
		DR16_StartDmaRecv(&dr16);
    if (DR16_WaitDmaCplt(20)) {
			     DR16_ParseData(&dr16);

    switch (dr16.data.sw_l) {
      case DR16_SW_UP:
          cmd_to_chassis.mode = CHASSIS_MODE_RELAX;
          break;
      case DR16_SW_MID:
          cmd_to_chassis.mode = CHASSIS_MODE_FOLLOW_GIMBAL;
          break;
      case DR16_SW_DOWN:
          cmd_to_chassis.mode = CHASSIS_MODE_ROTOR;
          break;
      default:
          cmd_to_chassis.mode = CHASSIS_MODE_RELAX;
          break;
    }

    cmd_to_chassis.ctrl_vec.vx = dr16.data.ch_l_y;
    cmd_to_chassis.ctrl_vec.vy = dr16.data.ch_l_x;
    cmd_to_chassis.ctrl_vec.wz = dr16.data.ch_r_x;
} else {
    DR16_Offline(&dr16);
}
			//	ChassisCmd_t tmp;
		
    osMessageQueuePut(task_runtime.msgq.chassis.cmd, &cmd_to_chassis, 0, 0);
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}